# -*- coding: cp1252 -*-
from Tkinter import *
from idlelib.TreeWidget import*
import tkFileDialog
import os
import tarfile
import sys

## pour recharger la mthode de slection
class Backup_TreeNode(TreeNode):
    def __init__(self, canvas, parent, item):
        TreeNode.__init__(self,canvas,parent,item)
        self.image_id=None
        if parent and parent.selected:
            self.selected=True
            self.item.all=True
        
    def redraw(self):
        if self.x!=None:##Pas encore cr et pas affich
            self.canvas.delete(self.image_id)
            self.drawicon()
            self.drawtext()
            
    def select(self, event=None):
        if self.selected:
            self.deselect()
            return
        self.selected = True
        self.item.all= True
        if self.item._IsExpandable():
            self.selecttree()
        self.redraw()
        #Remonter l'information
        #Si au niveau du parent tout les fils sont slectionner
        #Le noeud parent est entirement slectionn
        parent=self.parent
        while parent:
            A_sel=True
            parent.selected=True
            for fils in parent.children:
                if not (fils.selected and fils.item.all):
                    A_sel=False
                    break
            if A_sel:
                parent.item.all=True
            parent.redraw()
            parent=parent.parent

                
    def deselect(self, event=None):
        if not self.selected:
            return
        self.selected = False
        #Remonter l'information de slection partielle
        parent=self.parent
        while parent:
            parent.item.all=False
            #Dslecter le parent si aucun de ses fils n'est selecter
            parent.selected=False
            for fils in parent.children:
                if fils.selected:
                    parent.selected=True
            parent.redraw()
            parent=parent.parent
        if self.item._IsExpandable() :
            self.deselecttree()
        self.selected = False
        self.redraw()
    def selecttree(self):
        if not self.selected:
            self.select()
        for child in self.children:
            child.selecttree()

class Backup_TreeItem(TreeItem):
    def __init__(self, path):
        self.path = path
        self.expandable=os.path.isdir(path)
        self.all=False
    def GetText(self):
        return os.path.basename(self.path) or self.path
    def IsEditable(self):
        return False
    def SetText(self, text):
        pass
    def GetIconName(self):
        if  self.IsExpandable():
            return "folder"
        return "no_svg"
    def GetSelectedIconName(self):
        if self.IsExpandable():
            if self.all==True:
                return "svg_folder_all"
            else:
                return "svg_folder_part"
        return "svg"
    def IsExpandable(self):
        return self.expandable
    def GetSubList(self):
        try:
            names = os.listdir(self.path)
        except os.error:
            return []
        names.sort(lambda a, b: cmp(os.path.normcase(a), os.path.normcase(b)))
        sublist = []
        for name in names:
            item = Backup_TreeItem(os.path.join(self.path, name))
            sublist.append(item)
        return sublist


def create_menu(parent):
    menu=Menu(parent,tearoff=0)
    parent.configure(menu=menu)
    menu_jeu=Menu(menu,tearoff=0)   #tearoff pour supprimer la possibilit d'ouvrirle menu dans une fentre
    menu.add_cascade(label="Jeu de sauvegarde",underline=0,menu=menu_jeu)
    menu_jeu.add_command(label="Ouvre",underline=0,command=charge_jeu)
    menu_jeu.add_command(label="Sauve",underline=0,command=sauve_jeu)
    menu.add_separator()
    menu_back=Menu(menu,tearoff=0)
    menu.add_cascade(label="Sauvegardes",underline=0,menu=menu_back)
    if os.name=='nt':
        menu_disk=Menu(menu_back,tearoff=0)
        for C in 'CDEFGHIJKLMNOPQRSTUVWXYZ':
            global disk
            if os.path.exists(C+':\\'):
                menu_disk.add_radiobutton(label=C+':',command=change_source,variable=disk,value=C)
        menu_back.add_cascade(label="disque Source",underline=8,menu=menu_disk)
    menu_back.add_command(label="Destination",underline=0,command=change_dest)
    menu_back.add_command(label="Execution",underline=0,command=do_sauvegarde)
                     
    
    

def charge_jeu():
    global disk
    f=tkFileDialog.askopenfile(defaultextension='.bkup',filetypes=[('Jeu de sauvegarde ','*.bkup')])
    if not f:
        return
    for line in f:
        line=line[:-1] #saloperie de caractre de fin de ligne
        #print line
        Chemin=""
        objs=[node] #initialisation de la liste de recherche de dbut
        obj=None
        disque,reste=os.path.splitdrive(line)
        path=reste.split(os.sep) #Le chemin en liste pour le parcourt
        un=path.pop(0)
        un=disque+os.sep
        if os.name=='nt' and disk.get()!= disque[0]:
            disk.set(disque[0])
            change_source()
        while objs:
            obj=objs.pop()
            if obj.item.GetText()== un:
                #Descendre d'un cran dans le chemin et si on est au bout on a trouv ou on a chou
                if path:
                    un=path.pop(0)
                else:
                    break
                if obj.item.IsExpandable():
                    #Si les fils n'existent pas il faut les construire
                    if not obj.children:
                        sublist=obj.item.GetSubList()
                        for item in sublist:
                            obj.children.append(Backup_TreeNode(obj.canvas,obj,item))
                    #on est descendu d'un cran dans l'arborescence on recr la iste de recherche
                    objs=[]+obj.children
                    #Il n'est pas question que pop dtruise l'arboresecnce
                    #Objs=[]+obj.children recre une nouvelle liste
                    #Objs=obj.children Objs et obj.children sont la mme liste
                    #et ce qui est pop de l'ubn l'est de l'autre
        #on vrifie que l'on est bien arriv  bon port
        if obj.item.path==line:
            obj.select()
            obj.item.all=True
    f.close()
def sauve_jeu():
    f=tkFileDialog.asksaveasfile(defaultextension='.bkup',filetypes=[('Jeu de sauvegarde ','*.bkup')])
    def S1(f,obj):
        if obj.selected:
            if obj.item.all:
                f.write(obj.item.path+'\n')
            else:
                for noeud in obj.children:
                    S1(f,noeud)
    #Une rcursivit terminale qui devrait tre remplace par une boucle
    S1(f,node)
    f.close()
def change_dest():
    global bkupname
    bkupname=tkFileDialog.asksaveasfilename(initialfile=bkupname,defaultextension='tar.bz2',filetypes=[('Gnu tar bzip ','*.tar.bz2'),('Gnu tar gzip','*.tgz'),('Gnu tar','*.tar')])
def change_source():
    global node
    global sc
    node.destroy()
    item=Backup_TreeItem(disk.get()+':\\')
    node= Backup_TreeNode(sc.canvas,None,item)
    node.expand()    
def do_sauvegarde():
    global bkupname
    global root
    if not bkupname:
        change_dest()
    #Calcul du mode d'ouverture suivant l'extension
    toto,ext=os.path.splitext(bkupname)
    modes={'.tar':'w','.tgz':'w:gz','.bz2':'w:bz2'}
    archive=tarfile.open(bkupname,modes[ext])
    oldcursor=root.cget("cursor")
    root.configure(cursor="clock")
    objs=[node]
    while objs:
        obj=objs.pop(0)
        if obj.selected:
            if obj.item.all:
                #Je tar
                archive.add(obj.item.path)
            else:
                objs=objs+obj.children
    #Cette fois j'ai transform la rcursivit terminale
    archive.close()
    root.configure(cursor=oldcursor)




root = Tk()
bkupname=''
if os.name=='nt':
    item = Backup_TreeItem("C:\\")
    disk=StringVar()
    disk.set('C')
else:
    if os.name=='posix':
        item=Backup_TreeItem("/")
    else:
        print "dsol je ne fonctionne que sous windows ou unix"
        sys.exit(0)
root.configure(bd=0,bg="white")
root.focus_set()
root.title("Pytariste une sauvegare en python par B. Belguise")
create_menu(root)
sc = ScrolledCanvas(root, bg="white", highlightthickness=0, takefocus=1)
sc.frame.pack(expand=1,fil="both")
node= Backup_TreeNode(sc.canvas,None,item)
if sys.platform=='cygwin':
    cygdrive_item=Backup_TreeItem('/cygdrive')
    cygdrive_item.expandable=1
    node.children.append(Backup_TreeNode(node.canvas,node,cygdrive_item))
node.expand()
root.mainloop()
node.destroy()


